﻿Imports System.ComponentModel
Class MainWindow
End Class

Public Class CRecords
    Implements IEnumerable(Of CRecord)
    Private Items As IEnumerable(Of CRecord) = New CRecord() {New CRecord()}
    Public Function GetEnumerator() As System.Collections.Generic.IEnumerator(Of CRecord) Implements System.Collections.Generic.IEnumerable(Of CRecord).GetEnumerator
        Return Me.Items.GetEnumerator()
    End Function
    Private Function GetEnumerator1() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return Me.GetEnumerator()
    End Function
End Class

Public Class CRecord
    Implements INotifyPropertyChanged
    Private Sub DebugPrint(ByVal aMsg As String)
        Debug.Print(aMsg)
    End Sub
    Public Property DynEnumItem As CDynEnumItem
        Get
            If Me.DynEnumItemM Is Nothing Then Me.DynEnumItemM = Me.DynEnumItemValues.ElementAt(1)
            Me.DebugPrint("DynEnumItem.Get: Label='" & Me.DynEnumItemM.Label & "'")
            Return Me.DynEnumItemM
        End Get
        Set(ByVal value As CDynEnumItem)
            If value Is Nothing Then
                Me.DebugPrint("DynMenuItem.Set(Nothing)")
            Else
                Me.DebugPrint("DynMenuItem.Set(Label='" & value.Label & "')")
            End If
            ' If value Is Nothing Then value = Me.DynEnumItemValues.ElementAt(0)
            Try
                If value Is Nothing Then Throw New ArgumentNullException
                Me.DynEnumItemM = value
                Me.PropertyChangedRaise("DynEnumItem")
            Catch ex As Exception
                Me.DebugPrint(ex.Message)
                Throw ex
            End Try
        End Set
    End Property
    Private DynEnumItemM As CDynEnumItem
    Public ReadOnly Property DynEnumItemValues As IEnumerable(Of CDynEnumItem)
        Get
            If Me.DynEnumItemValuesM Is Nothing Then Me.DynEnumItemValuesM = New CDynEnumItem() {New CDynEnumItem(""), New CDynEnumItem("A"), New CDynEnumItem("B")}
            Return Me.DynEnumItemValuesM
        End Get
    End Property
    Private DynEnumItemValuesM As IEnumerable(Of CDynEnumItem)

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
    Private Sub PropertyChangedRaise(ByVal aPropertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(aPropertyName))
    End Sub
End Class

        Public Class CDynEnumItem
    Friend Sub New(ByVal aLabel As String)
        Me.Label = aLabel
    End Sub
    Public Property Label As String
End Class

